'Program sterowania multipleksowego wywietlaczem matrycowym 7x5 LED
'za pomoc rejestru 74LS164
'Znak do wywietlenia jest adowany do zmiennej Znak typu String
'Czstotliwo sterowania kolumn wywietlacza wynosi ok. 333 Hz
'czyli czstotliwo odwieania kolumn wywietlacza
'wyniesie ok. 333/5 = ok. 67 Hz

$REGFILE = "m8def.dat"					'informuje kompilator o pliku
							'dyrektyw mikrokontrolera
$CRYSTAL = 8000000					'informuje kompilator 
							'o czstotliwoci oscylatora
							'taktujcego mikrokontroler
Config Pind.0 = Output					'linia PD0 jako wyjciowa
Config Pind.1 = Output					'linia PD1 jako wyjciowa
Config Pinb.0 = Output					'linia PB0 jako wyjciowa
Config Pinb.1 = Output					'linia PB1 jako wyjciowa
Config Pinb.2 = Output					'linia PB2 jako wyjciowa
Config Pinb.3 = Output					'linia PB3 jako wyjciowa
Config Pinb.4 = Output					'linia PB4 jako wyjciowa

Config Timer0 = Timer , Prescale = 256
							'konfiguracja Timer0 jako 
							'timer z podziaem preskalera 
							'przez 256

Declare Sub Pob_w_zn					'procedura bezparametrowa
							'pobierajca kod wywietlanej 
							'kolumny znaku z odpowiednich 
							'tablic staych
On Timer0 Mult_wysw_matr				'przerwanie od przepenienia 
							'Timer0, skok nastpi do 
							'podprogramu Mult_wysw_matr
Dim Znak As String * 1					'zmienna, do ktrej wpisywany 
							'jest znak do wywietlenia
Dim Nr_kol As Byte					'zmienna okrelajca numer 
							'zapalanej kolumny wywietlacza
Dim Kod_zn As Byte					'zmienna, do ktrej jest 
							'wpisywany kod ASCII 
							'wywietlanego znaku
Dim Kol_zn As Byte					'zmienna, do ktrej jest 
							'wpisywany kod wywietlanej 
							'kolumny z tablicy

C1 Alias Portb.0					'przypisanie linii PB0 nazwy C1
C2 Alias Portb.1					'przypisanie linii PB1 nazwy C2
C3 Alias Portb.2					'przypisanie linii PB2 nazwy C3
C4 Alias Portb.3					'przypisanie linii PB3 nazwy C4
C5 Alias Portb.4					'przypisanie linii PB4 nazwy C5

Enable Interrupts					'odblokowanie globalnego systemu
							'przerwa
Enable Timer0						'odblokowanie przerwania od
							'przepenienia Timer0
Load Timer0 , 94					'wpisanie do licznika wartoci
							'pocztkowej 162, bo 
							'256 - 94 = 162

Do							'pocztek nieskoczonej ptli
	Znak = "B"					'wpisanie do wywietlenia znaku B
	Wait 1						'opnienie 1 sekundy
	Znak = "a"					'wpisanie do wywietlenia znaku a
	Wait 1						'opnienie 1 sekundy
	Znak = "s"					'wpisanie do wywietlenia znaku s
	Wait 1						'opnienie 1 sekundy
	Znak = "c"					'wpisanie do wywietlenia znaku c
	Wait 1						'opnienie 1 sekundy
	Znak = "o"					'wpisanie do wywietlenia znaku o
	Wait 1						'opnienie 1 sekundy
	Znak = "m"					'wpisanie do wywietlenia znaku m
	Wait 1						'opnienie 1 sekundy
Loop							'koniec ptli nieskoczonej
End							'koniec programu

Sub Pob_w_zn						'definicja procedury 
							'pobierajcej i wpisujcej kody 
							'kolumn wywietlacza na 7 bitw 
							'portu D
	Kod_zn = Asc(Znak)				'zamiana zmiennej Znak na kod 
							'ASCII
	Select Case Nr_kol				'w zalenoci od wartoci Nr_kol
							'- numeru kolumny wykonaj:
	Case 0:						'gdy Nr_kol = 1
		Kol_zn = Lookup(Kod_zn , Kol1)		'wpisanie do zmiennej Kol_zn
							'kodu znaku z tablicy o kodzie 
							'ASCII zawartym w Kod_zn dla 
							'kolumny 1
	Case 1:						'gdy Nr_kol = 2
		Kol_zn = Lookup(Kod_zn , Kol2)		'wpisanie do zmiennej Kol_zn
							'kodu znaku z tablicy o kodzie 
							'ASCII zawartym w Kod_zn dla 
							'kolumny 2
	Case 2:						'gdy Nr_kol = 3
		Kol_zn = Lookup(Kod_zn , Kol3)		'wpisanie do zmiennej Kol_zn
							'kodu znaku z tablicy o kodzie 
							'ASCII zawartym w Kod_zn dla 
							'kolumny 3
	Case 3:						'gdy Nr_kol = 4
		Kol_zn = Lookup(Kod_zn , Kol4)		'wpisanie do zmiennej Kol_zn
							'kodu znaku z tablicy o kodzie 
							'ASCII zawartym w Kod_zn dla 
							'kolumny 4
	Case 4:						'gdy Nr_kol = 5
		Kol_zn = Lookup(Kod_zn , Kol5)		'wpisanie do zmiennej Kol_zn
							'kodu znaku z tablicy o kodzie 
							'ASCII zawartym w Kod_zn dla 
							'kolumny 5
	End Select					'koniec instrukcji warunkowej
	Shiftout Portd.0 , Portd.1 , Kol_zn , 0		'wysanie wartoci zmiennej 
							'Kol_zn do rejestru przesuwnego
End Sub							'koniec procedury

Mult_wysw_matr:						'podprogramu obsugi przerwania 
							'od przepenienia Timer0
	Load Timer0 , 94				'wpisanie do licznika wartoci
							'pocztkowej
	Set C1						'wygaszenie kolumny 1
	Set C2						'wygaszenie kolumny 2
	Set C3						'wygaszenie kolumny 3
	Set C4						'wygaszenie kolumny 4
	Set C5						'wygaszenie kolumny 5
	Call Pob_w_zn					'wywoanie procedury pobierajcej
							'kod wywietlanej kolumny 
							'z tablic 
	Select Case Nr_kol				'w zalenoci od wartoci Nr_kol
							'wykonaj:
	Case 0:						'gdy Nr_kol = 0
		Reset C1  				'wczenie kolumny 1
	Case 1:						'gdy Nr_kol = 1
		Reset C2				'wczenie kolumny 2
	Case 2:						'gdy Nr_kol = 2
		Reset C3				'wczenie kolumny 3
	Case 3:						'gdy Nr_kol = 3
		Reset C4				'wczenie kolumny 4
	Case 4:						'gdy Nr_kol = 4
		Reset C5				'wczenie kolumny 5
	End Select					'koniec instrukcji wyboru
	Incr Nr_kol					'zwikszenie o jeden warto 
							'Nr_kol
	If Nr_kol = 5 Then				'jeli warto Nr_kol osignie 5,
		Nr_kol = 0				'to wyzerowanie wartoci Nr_kol
	End If
Return							'powrt z podprogramu przerwania

Kol1:							'tablica kodw Kol1 dla 
							'pierwszej kolumny wywietlacza 
							'- kolejno kodw odpowiada 
							'numerom ASCII
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 107 , 109 , 29 , 73 , 127 ,
Data 127 , 127 , 107 , 119 , 127 , 119 , 127 , 125 , 65 , 127 ,
Data 94 , 61 , 115 , 13 , 97 , 127 , 73 , 79 , 127 , 127 , 119 ,
Data 107 , 127 , 95 , 89 , 64 , 0 , 65 , 0 , 0 , 0 , 65 , 0 ,
Data 127 , 125 , 0 , 0 , 0 , 0 , 65 , 0 , 65 , 0 , 78 , 63 , 1 ,
Data 3 , 1 , 28 , 15 , 60 , 127 , 43 , 127 , 111 , 126 , 127 ,
Data 125 , 0 , 113 , 113 , 113 , 119 , 103 , 0 , 127 , 125 , 0 ,
Data 127 , 96 , 96 , 113 , 96 , 119 , 96 , 118 , 111 , 97 , 99 ,
Data 97 , 110 , 103 , 110 , 127 , 127 , 127 , 119 , 119

Kol2:							'tablica kodw Kol2 dla drugiej
							'kolumny wywietlacza 
							'- kolejno kodw odpowiada 
							'numerom ASCII
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 15 , 0 , 85 , 27 , 54 , 47 , 99 ,
Data 62 , 119 , 119 , 122 , 119 , 124 , 123 , 58 , 94 , 60 , 62 ,
Data 107 , 46 , 86 , 56 , 54 , 54 , 73 , 74 , 107 , 107 , 62 ,
Data 63 , 54 , 59 , 54 , 62 , 62 , 54 , 55 , 62 , 119 , 62 , 126 ,
Data 119 , 126 , 95 , 111 , 62 , 55 , 62 , 55 , 54 , 63 , 126 ,
Data 125 , 126 , 107 , 119 , 58 , 0 , 75 , 62 , 95 , 126 , 63 ,
Data 106 , 118 , 110 , 110 , 106 , 64 , 90 , 119 , 110 , 126 ,
Data 123 , 62 , 111 , 119 , 110 , 107 , 107 , 119 , 106 , 1 ,
Data 126 , 125 , 126 , 117 , 122 , 108 , 119 , 127 , 62 , 119 , 99

Kol3:							'tablica kodw Kol3 dla trzeciej
							'kolumny wywietlacza 
							'- kolejno kodw odpowiada 
							'numerom ASCII
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 6 , 127 , 107 , 0 , 119 , 42 , 31 , 93 ,
Data 93 , 65 , 65 , 121 , 119 , 124 , 119 , 54 , 0 , 58 , 46 , 91 ,
Data 46 , 54 , 55 , 54 , 54 , 73 , 73 , 93 , 107 , 93 , 58 , 48 ,
Data 59 , 54 , 62 , 62 , 54 , 55 , 54 , 119 , 0 , 62 , 107 , 126 ,
Data 103 , 119 , 62 , 55 , 58 , 51 , 54 , 0 , 126 , 126 , 113 ,
Data 119 , 120 , 54 , 62 , 96 , 62 , 63 , 126 , 95 , 106 , 110 ,
Data 110 , 110 , 106 , 55 , 90 , 111 , 32 , 110 , 117 , 0 , 115 ,
Data 111 , 110 , 107 , 107 , 111 , 106 , 110 , 126 , 126 , 121 ,
Data 123 , 122 , 106 , 73 , 0 , 73 , 85 , 85

Kol4:							'tablica kodw Kol4 dla czwartej
							'kolumny wywietlacza 
							'- kolejno kodw odpowiada 
							'numerom ASCII
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 15 , 0 , 85 , 108 , 93 , 127 , 62 ,
Data 99 , 119 , 119 , 127 , 119 , 127 , 111 , 46 , 126 , 54 , 22 ,
Data 0 , 46 , 54 , 47 , 54 , 53 , 127 , 127 , 62 , 107 , 107 , 55 ,
Data 62 , 59 , 54 , 62 , 93 , 54 , 55 , 54 , 119 , 62 , 1 , 93 ,
Data 126 , 95 , 123 , 62 , 55 , 61 , 53 , 54 , 63 , 126 , 125 , 126 ,
Data 107 , 119 , 46 , 62 , 75 , 0 , 95 , 126 , 111 , 106 , 110 ,
Data 110 , 118 , 106 , 63 , 90 , 111 , 126 , 33 , 110 , 126 , 111 ,
Data 111 , 110 , 107 , 115 , 111 , 106 , 126 , 125 , 125 , 126 ,
Data 117 , 122 , 102 , 62 , 127 , 119 , 99 , 119

Kol5:							'tablica kodw Kol5 dla pitej
							'kolumny wywietlacza 
							'- kolejno kodw odpowiada 
							'numerom ASCII
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 , 127 ,
Data 127 , 127 , 127 , 127 , 127 , 107 , 91 , 92 , 122 , 127 , 127 ,
Data 127 , 107 , 119 , 127 , 119 , 127 , 95 , 65 , 127 , 78 , 57 ,
Data 123 , 49 , 121 , 31 , 73 , 67 , 127 , 127 , 127 , 107 , 119 ,
Data 79 , 65 , 64 , 73 , 93 , 99 , 62 , 63 , 80 , 0 , 127 , 63 , 62 ,
Data 126 , 0 , 0 , 65 , 79 , 66 , 78 , 57 , 63 , 1 , 3 , 1 , 28 , 15 ,
Data 30 , 127 , 43 , 127 , 111 , 126 , 127 , 112 , 113 , 125 , 0 ,
Data 115 , 95 , 65 , 112 , 127 , 127 , 127 , 127 , 112 , 112 , 113 ,
Data 119 , 96 , 119 , 125 , 125 , 96 , 99 , 97 , 110 , 97 , 110 ,
Data 127 , 127 , 127 , 119 , 119

