'Program  sterowania dwoma ukadami DS1820 doczonymi
'do tej samej magistrali 1-Wire

$regfile = "m8def.dat"                                      'informuje kompilator o pliku
      'dyrektyw mikrokontrolera
$crystal = 8000000                                          'informuje kompilator
      'o czstotliwoci oscylatora
      'taktujcego mikrokontroler
Config Pinb.1 = Input                                       'linia PB1 jako wejciowa
Config Lcd = 16 * 2                                         'konfigurowanie typu
      'wywietlacza LCD
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5       'konfigurowanie linii
      'mikrokontrolera, do ktrych
      'jest doczony wywietlacz LCD
Config 1wire = Portb.0                                      'konfigurowanie linii magistrali
      '1-Wire
Declare Sub Odcz_temp(czujnik As Byte)                      'procedura odczytu temperatury
      'z ukadu DS1820 z parametrem,
      'ktry wskazuje numer czujnika
      'temperatury
Declare Sub Zapisz_id                                       'procedura zapisu numeru ID do
      'ukadu DS1820
Dim Temperatura(2) As Byte                                  'tablica dwch zmiennych typu
      'Byte na zmierzon temperatur
Dim Id(8) As Byte                                           '8-elementowa tablica na numer
      'ID
Dim I As Byte                                               'zmienna licznikowa
Dim J As Byte                                               'zmienna licznikowa
Dim K As Byte                                               'zmienna licznikowa
Dim Liczba_ukl As Byte                                      'zmienna, do ktrej wpisywana
      'jest liczba ukadw doczonych
      'do magistrali 1-Wire
S1 Alias Pinb.1                                             'przypisanie nazwie Pinb.1
      'nazwy S1

      'definicja znaku stopnia
Deflcdchar 0 , 7 , 5 , 7 , 32 , 32 , 32 , 32 , 32

Set Portb.1                                                 'doczenie do linii PB1
      'rezystora podcigajcego
Cls                                                         'czyszczenie LCD
Liczba_ukl = 1wirecount()                                   'odczytanie liczby ukadw
      'doczonych do magistrali
      '1-Wire
If S1 = 0 Then                                              'jeli przycisk S1 naciniety,
      'to
 Lcd "Liczba ukladow: " ; Liczba_ukl
      'wywietlenie na LCD liczby
      'ukadw doczonych do
      'magistrali
 If Liczba_ukl > 0 Then                                     'jeli liczba ukadw wiksza od
      '0 to
  Id(1) = 1wsearchfirst()                                   'odczytanie numeru seryjnego
      'pierwszego doczonego do
      'magistrali ukadu
  For I = 1 To 8                                            'ptla wykonywana 8 razy
   Writeeeprom Id(i) , I                                    'zapisanie odczytanego ID do
      'pamici EEPROM w sowach 1...8
  Next I                                                    'zwikszenie wartoci I o jeden
 End If
 If Liczba_ukl > 1 Then                                     'jeli liczba ukadw jest
      'wiksza od 1, to
  Id(1) = 1wsearchnext()                                    'odczytanie numeru seryjnego
      'kolejnego ukadu (drugiego
      'DS1820)
  J = 0                                                     'warto pocztkowa zmiennej
      'J = 0
  For I = 9 To 16                                           'ptla wykonywana 8 razy od
      'I = 9 do I = 16
   Incr J                                                   'zwikszenie wartoci J o jeden
   Writeeeprom Id(j) , I                                    'zapisanie numeru ID drugiego
      'ukadu do pamici EEPROM
      'w sowach 9...16
  Next I                                                    'zwikszenie o jeden wartoci I
 End If
 Lowerline                                                  'kursor do drugiej linii LCD
 Lcd "Prog ok"                                              'wywietlenie komunikatu
      'o zakoczeniu odczytu numerw
      'ID
 Do                                                         'ptla nieskoczona Do...Loop
 Loop
End If

Do                                                          'pocztek ptli programu
      'gwnego
 Home                                                       'kursor na pocztek pierwszej
      'linii
 For K = 1 To Liczba_ukl                                    'ptla wykonywana od K = 1 do
      'liczby ukadw doczonych do
      '1-Wire
  Call Odcz_temp(k)                                         'wywoanie procedury pomiaru
      'temperatury z parametrem K
  If Temperatura(2) = 0 Then                                'jeli warto Temperatura(2)
      '= 0 to temperatura dodatnia
      'wywietlenie temperatury
      'dodatniej
   Lcd "Temp" ; K ; ": " ; Temperatura(1) ; Chr(0) ; "C"
  Else                                                      'w przeciwnym razie wywietlenie
      'temperatury ujemnej
   Lcd "Temp" ; K ; ": -" ; Temperatura(1) ; Chr(0) ; "C"
  End If
  Lowerline                                                 'kursor w drugiej linii LCD
 Next K                                                     'zwikszenie o 1 wartoci K
Loop                                                        'koniec ptli Do...Loop
End                                                         'koniec programu

Sub Odcz_temp(czujnik As Byte)                              'procedura pomiaru temperatury
      '- parametr Czujnik okrela
      'numer czujnika
 If Czujnik = 1 Then                                        'jeli Czujnik = 1 to
      'odczytywany jest z pamici
      'EEPROM numer ID czujnika 1
  For I = 1 To 8                                            'ptla wykonywana od I = 1 do
      'I = 8
   Readeeprom Id(i) , I                                     'odczyt ID z pamici EEPROM
      'czujnika pierwszego
  Next I                                                    'zwikszenie o 1 wartoci I
 End If
 If Czujnik = 2 Then                                        'jeli Czujnik = 2 to
      'odczytywany jest z pamici
      'EEPROM numer ID czujnika 2
  J = 0                                                     'warto pocztkowa zmiennej
      'J = 0
  For I = 9 To 16                                           'ptla wykonywana 8 razy od
      'I = 9 do I = 16
   Incr J                                                   'zwikszenie wartoci J o jeden
   Readeeprom Id(j) , I                                     'odczyt numeru ID z pamici
      'EEPROM z sw 9...16 dla
      'czujnika 2
  Next I                                                    'zwikszenie o 1 wartoci I
 End If

 1wreset                                                    'reset magistrali 1-Wire
 Call Zapisz_id                                             'wybranie czujnika poprzez zapis
      'do niego numeru ID aktualnie
      'obsugiwanego ukadu DS1820
 1wwrite &H44                                               'start pomiaru przez ukad
      'DS1820
 Waitms 750                                                 'opnienie na czas pomiaru
 1wreset                                                    'reset magistrali 1-Wire
 Call Zapisz_id                                             'wybranie czujnika poprzez zapis
      'do niego numeru ID aktualnie
      'obsugiwanego ukadu DS1820
 1wwrite &HBE                                               'komenda odczytu ukadu DS1820
      'zmierzonej temperatury
 Temperatura(1) = 1wread(2)                                 'odczyt zmierzonej temperatury
      'do tablicy Temperatura
 1wreset                                                    'reset magistrali 1-Wire
 If Err = 1 Then                                            'jeli brak ukadu DS1820
      'doczonego do 1-Wire, to
  Cls                                                       'czyszczenie LCD
  Lcd "Brak ukladu"                                         'wywietlenie komunikatu o braku
      'ukadu
  Do                                                        'nieskoczona ptla Do...Loop
      'w celu wstrzymania dziaania
      'programu
  Loop
 End If
 If Temperatura(2) > 0 Then                                 'jeli zmienna Temperatura(2)
      '> 0, to temperatura ujemna
      'przeliczenie temperatury
      'ujemnej
  Temperatura(1) = 256 - Temperatura(1)
 End If                                                     'koniec warunku
 Temperatura(1) = Temperatura(1) / 2
      'dalsze przeliczenie odczytanej
      'temperatury dodatniej jak
      'i ujemnej
End Sub                                                     'koniec procedury pomiaru

Sub Zapisz_id                                               'definicja procedury zapisu
      'numeru ID do ukadw DS1820
 1wwrite &H55                                               'wysanie komendy zapisu numeru
      'ID do ukadw
 For I = 1 To 8                                             'ptla wykonywana od I = 1 do
      'I = 8
  1wwrite Id(i)                                             'wysanie do czujnikw numeru ID
      'z tablicy Id
 Next I                                                     'zwikszenie o 1 wartoci I
End Sub                                                     'koniec procedury
